Differences between revisions 47 and 48
Revision 47 as of 2010-03-10 15:32:44
Size: 4513
Comment:
Revision 48 as of 2010-03-10 16:06:45
Size: 4989
Comment: Added section on automatic upgrades, edited External links section
Deletions are marked like this. Additions are marked like this.
Line 74: Line 74:
Open the file {{{/etc/apt/preferences}}} in an editor of your choice and insert the following text:  1. Open the file {{{/etc/apt/preferences}}} in an editor of your choice.
1. Insert the text below.
 1. Save and exit.
Line 82: Line 83:
After changing APT's behavior in that file, it will act like this:

If a package was installed from Backports.org and there is a
newer version there, it will be upgraded from there.
Other packages that are available from Backports.org will not be upgraded to the Backports.org version unless explicitly
stated with {{{-t lenny-backports}}}.
Line 84: Line 91:
 * http://www.backports.org for more information
 * http://doc.cliss21.com/index.php?title=Backports contains information on how to backport packages, as well as some step-by-steps simple examples to start with.
 * http://svn.madduck.net/pub/bin/debian/bpoprep script automates that process. You need some functions from http://svn.madduck.net/pub/bin/debian/dfunctions.
 * [[http://www.backports.org|Backports.org]] for more information
 * [[http://doc.cliss21.com/index.php?title=Backports|Article about backports on cliss21.com]]: contains information on how to backport packages, as well as some step-by-steps simple examples to start with.
 * [[http://svn.madduck.net/pub/bin/debian/bpoprep|Bpoprep]] (dead link!): A script that automates that process. You need some functions from http://svn.madduck.net/pub/bin/debian/dfunctions (dead link!).

Translation(s): English - Français- Italiano

(!) Discussion


You are running Debian stable, because you prefer the stable Debian tree. It runs great, there is just one problem: The software is a little bit outdated compared to other distributions. That is where backports come in.

Backports are recompiled packages from testing (mostly) and unstable (in a few cases only, e.g. security updates), so they will run without new libraries (wherever it is possible) on a stable Debian distribution. It is recommended to pick out single backports which fit your needs, and not to use all backports available.

Note that this page refers to etch as stable, but you can substitute with lenny for the latest stable (April 2009).

There's a useful comparison of package versions available for backporting to lenny at this page.


Configuring your stable system

Verifying backports

In order to verify the integrity of downloaded backports before installing them, apt needs the Backports.org archive key. The package debian-backports-keyring contains this key. So you should install it first.

Adding the repository

Using Synaptic

  • Open Synaptic
  • Go to:

   Configuration > Repository
  • Add this repository:

    synaptic.png

Using the command line

Become root and open the file /etc/apt/sources.list in your favorite editor:

human@debian:~$ su
Password:
debian:/home/human# nano /etc/apt/sources.list

Add the following lines:

# Backports.org repository
deb http://www.backports.org/debian/ etch-backports main contrib non-free

If you are a free software enthusiast, you might want to remove the contrib and non-free sections. (See Debian sections for details.)

Now that you have added the repository, update apt's cache to include the backports in the list of available packages:

debian:/home/human# aptitude update

Done.

Using backports

Finding backports

There are a several different ways to find out if a backport of a certain Debian package exists. A pretty convenient one is using Debian's web-based package search (packages.debian.org). If you are running Iceweasel, simply use the built-in search plugin (Deb Search).

Installing backports on the command line

The backports repository is deactivated by default. So, if you want to install a backported package, you will have to state that explicitly.

For example:

debian:/home/human# aptitude -t lenny-backports install iceweasel

The -t option here specifies lenny-backports as the target release. This will install Iceweasel 3.5 from Backports.org instead of version 3.0 from the Debian stable release.

Automatic upgrades

Because the Backports.org repository is deactivated by default, your installed backports won't recieve upgrades automatically. However, you can use pinning to cause APT to perform automatic upgrades. Pinning basically means controlling which version of which package is to be selected for installation. (See the APT HOWTO and man apt_preferences for further explanation.)

In order to make APT perfom automatic upgrades of installed backports, follow these steps:

  1. Open the file /etc/apt/preferences in an editor of your choice.

  2. Insert the text below.
  3. Save and exit.

# APT PINNING PREFERENCES
Package: *
Pin: release a=lenny-backports
Pin-Priority: 200

After changing APT's behavior in that file, it will act like this:

If a package was installed from Backports.org and there is a newer version there, it will be upgraded from there. Other packages that are available from Backports.org will not be upgraded to the Backports.org version unless explicitly stated with -t lenny-backports.

External links


  • ?CategoryDistributionRelease